diff --git a/test/py/tests/test_efi_capsule/test_files/SIGNER.crt b/test/py/tests/test_efi_capsule/test_files/SIGNER.crt
new file mode 100644
index 0000000000..722a4e2483
--- /dev/null
+++ b/test/py/tests/test_efi_capsule/test_files/SIGNER.crt
@@ -0,0 +1,19 @@
+-----BEGIN CERTIFICATE-----
+MIIDDTCCAfWgAwIBAgIUGGjxXEUS+sBJaSOBz4u0MJRWdcowDQYJKoZIhvcNAQEL
+BQAwFjEUMBIGA1UEAwwLVEVTVF9TSUdORVIwHhcNMjMwNzI3MDY1NjQzWhcNMzMw
+NzI0MDY1NjQzWjAWMRQwEgYDVQQDDAtURVNUX1NJR05FUjCCASIwDQYJKoZIhvcN
+AQEBBQADggEPADCCAQoCggEBAMUEYpFf8i/zLX6/4bhUAIrLWCxaLCqGscZ85DSU
+SagMu+9DpCDrJSzgZQFj2+YSc4JSoBDs9u/JN+HNH+hK255Slzf8+Pl2YeRjTyCA
+7k6u0s2nFpLJkMPBzqyrEYP+fNrGsTtIlvutef2MPs8WfgyzB5CSRx/K40PirQHE
+Lt5HfLJ8WOvPAbdZ4z+PDm5LrZReewJOYHVKQepAY8z3Dsy3ZBnXGI/1ZYgMfTU0
+sBCfTtEBJb+ja+eKepw93IuxPLdN1ZXW1YUiBTs7h+BUAJr+Qjt/zvWl2ms1+sQf
+dHtsMa+WmTLu0XHCGOEfgX/fdTWv1GaelMTxl9Lzqug/+8cCAwEAAaNTMFEwHQYD
+VR0OBBYEFLH9hYGrnXfQ/CfAMaMAh64xJxTCMB8GA1UdIwQYMBaAFLH9hYGrnXfQ
+/CfAMaMAh64xJxTCMA8GA1UdEwEB/wQFMAMBAf8wDQYJKoZIhvcNAQELBQADggEB
+ACSmt+2O8mNT5K232P2BOPt3r2v3M+HZFsjb54s+wSiY5tS1KBFJbMehGKhwNZRz
+uEIp1RJnsh9Kg8Cnzh2Hpgwnycx2sipbTXN0Frz8QuC3zbAqhrcalaKFOuSXbY6O
+mBBJDJENj+d57yzHxT3XvSmAu62UMf2hwJqIqQfA7+wrV2VGEbrY4O9KY6O4Mj2f
+vS9WjN3840xQCqsohwbU9u9GpHYb6eFQ+jiit/yqYVlJCSDN812Fv1TYOPzLqG8L
+VCCqqpPRJX0E13kPAafoNK5UA2OKglgosvufWzwJ3Mn0Al8BQnv5rRnBoTxJLDef
+n+uX7jeUW6LfIH5s8cMrA2Y=
+-----END CERTIFICATE-----
diff --git a/test/py/tests/test_efi_capsule/test_files/SIGNER.esl b/test/py/tests/test_efi_capsule/test_files/SIGNER.esl
new file mode 100644
index 0000000000000000000000000000000000000000..3d584cd44a22e0b9c5414f54a3a5bc24504f0a71
GIT binary patch
diff --git a/test/py/tests/test_efi_capsule/test_files/SIGNER.key b/test/py/tests/test_efi_capsule/test_files/SIGNER.key
new file mode 100644
index 0000000000..e124cd35f0
--- /dev/null
+++ b/test/py/tests/test_efi_capsule/test_files/SIGNER.key
@@ -0,0 +1,28 @@
+-----BEGIN PRIVATE KEY-----
+MIIEvgIBADANBgkqhkiG9w0BAQEFAASCBKgwggSkAgEAAoIBAQDFBGKRX/Iv8y1+
+v+G4VACKy1gsWiwqhrHGfOQ0lEmoDLvvQ6Qg6yUs4GUBY9vmEnOCUqAQ7PbvyTfh
+zR/oStueUpc3/Pj5dmHkY08ggO5OrtLNpxaSyZDDwc6sqxGD/nzaxrE7SJb7rXn9
+jD7PFn4MsweQkkcfyuND4q0BxC7eR3yyfFjrzwG3WeM/jw5uS62UXnsCTmB1SkHq
+QGPM9w7Mt2QZ1xiP9WWIDH01NLAQn07RASW/o2vninqcPdyLsTy3TdWV1tWFIgU7
+O4fgVACa/kI7f871pdprNfrEH3R7bDGvlpky7tFxwhjhH4F/33U1r9RmnpTE8ZfS
+86roP/vHAgMBAAECggEAMvsIAIM52cOM1bwUTgzamQ+2UL/Cpvx0ux5tNNfcWXJ2
+HRs9ONFwLLUiHeJ3sAi9QA9eYRLYcUL5xWG9bHAWdVj8zV2WFYNXIHC8NHZ4c/7U
+CKhAdJpY7fbUIqUfoq6zIy+ABA2sGBMTOpNUW2UAGAwpnHTll6n59gKNbyQTVqvn
+swoHqutRaveshZeiCvOTEjoMUaBkMG5FWmsOI8qRrzJZx+K6A4hJxMQOnNN75wa/
+RtTf91Howw9/mxDzHjT42LTfWKPrJ0H3zoIG+4cgS7cRftNKi8L5OZnw6LvyJb6l
+wHJWPFklCDTQMq/NNMldgqtN5JuRDyUi8a24LcKI9QKBgQDiKkTr2wrzMXIEud14
+7x/0OY8fOwstKdkaeZ9VxsQg7AurVheEbjNYZXiragakg2vk5AWFJrwyv1RTlBnT
+IvvFIIshNiy3Oz6WJBG4WOwsGVrr47T2T3atiB/N8NBfb2jwHahMzjXZIvCA+FaE
+XJ9xfqH3uNAEamdI7Li7fFs8iwKBgQDfAcVeF2KxLLYoyfgWFoabchXx+FumjYgO
+tdv46kyKFWofss+W0KMIXx8KjDETbm0RL0IY1NW9wghTuLi581ie0eMTkwnlXDSG
+5Y+6sEKo3+9qkp+ZX/V62PhSwCt3O959nJZJsjICRfW73/Blz01LUiRxuEithdq2
+xoTvt1S5NQKBgH2kbdV5QoQIHAd0Gg1tCptqvo/jBTp53RpQJqxIV/zSJUlx8m6n
+qe6ZsIfJxxbty6rE4iwucK7gi8BCrnYVITlJ8wDoT78bMpHGR/HZtJprG4+gWI/d
+ZVjSHpkSBzB9fBao4y6IAHI4btO3Ipk1u34Zk3FDQoyxb9+bYqUFWMoxAoGBAJd0
+H3PYlAlaIViwWlG9+KtHnwnXr3787iN3dS6nCVZaVtmyWfPGPIMp/u3t6kKVI3Oh
+UdWFbqhSR898S9DWKSCr0PlxSi5AIdhfve5/WLZSZ8pMTCIhHpnRE004AA0ZVvCe
+UR8562bJ1qtC2oR6drcp0WB+VLWsi67IQm5/ZwXlAoGBAM09vlTKsVeKpMGly34m
+GkzapC921p7SHddAALhTt3vfUFnVkIYrmyWCtHmuTTQljm5ZQlS/YE4664j5VaJb
+7yeQKFhPi9B848+WVdnEJspmz11BZorS0TMhYn3/eArXKalLMhhRq0HqWJjc+8vu
+M1o40Gn1NdsvzQgiwi0JwAwS
+-----END PRIVATE KEY-----
diff --git a/test/py/tests/test_efi_capsule/test_files/SIGNER2.crt b/test/py/tests/test_efi_capsule/test_files/SIGNER2.crt
new file mode 100644
index 0000000000..25da91a873
--- /dev/null
+++ b/test/py/tests/test_efi_capsule/test_files/SIGNER2.crt
@@ -0,0 +1,19 @@
+-----BEGIN CERTIFICATE-----
+MIIDDTCCAfWgAwIBAgIUA+466jn5wSD1ufVxtNZUYbC2eyUwDQYJKoZIhvcNAQEL
+BQAwFjEUMBIGA1UEAwwLVEVTVF9TSUdORVIwHhcNMjMwNzI3MDY1NjU5WhcNMzMw
+NzI0MDY1NjU5WjAWMRQwEgYDVQQDDAtURVNUX1NJR05FUjCCASIwDQYJKoZIhvcN
+AQEBBQADggEPADCCAQoCggEBAJvgRltjaxviomhFdY2V0hrLw9MxsxvuCGhEW7H0
+Xh7wg/7qufBVO7hY/f0H3+Q1TEKRH2/j6sio2l+2CC+Pf4e4KxWJl1pLe3RgjtMB
+zfuRkEqoF4rQyYRBL47P8fqSCvSdap+olj2O7K0iiYgrsJjLeq7zpOFRTu3Mxy6a
+ePw3by8OqLVLlkpEXuC2nZIpUCvaBtp2hi0qbbnaPOnEn4HH9d7l8C9NvIGd7IXf
+knW0+NJna7aMgjfI+Em+ZIfHed+s2mXgG5dzgMK+iPWjuePFGTRhXsJAG1jw4lVn
+haYJ0LgGdwSSoxx/cES/kGzRKik0zFACT9ke1u+jLQC17KMCAwEAAaNTMFEwHQYD
+VR0OBBYEFK8pSvdztiocjuXQ6M37rgtQQjTfMB8GA1UdIwQYMBaAFK8pSvdztioc
+juXQ6M37rgtQQjTfMA8GA1UdEwEB/wQFMAMBAf8wDQYJKoZIhvcNAQELBQADggEB
+ABWO4IiahT5yukHgOwHIr7yj0OeBuH8dVlM8KCWUk1Vr6+vJNkHClvWbsiLuT7ns
+o1M27aCeagHWdtB1OmtaHKiFz+UpxIeVV1Ti6+1oshqg71xVCr6BY8+PzZiEj0r7
+auC1PEr4UtizmVAAyodf8lUaHGmU6zLzcCr9RtPhr9/5gq86V0IsXNn3p74CVf3k
+E8++FpNNBm43tmsWWKV4n4GyJHPNm1W/8P6HnFx4RKHuyNyUngA5axUFX/CvJ4jC
+RmE4Rxb2lncOumXx0/N4iC9SpfL78IcVxOyIpErnx3GLSvsEt5+TfLnLd9Y4IiOV
+mFrCCJRGrqGwmlZoDwKf2ZA=
+-----END CERTIFICATE-----
diff --git a/test/py/tests/test_efi_capsule/test_files/SIGNER2.key b/test/py/tests/test_efi_capsule/test_files/SIGNER2.key
new file mode 100644
index 0000000000..73b7d7d26f
--- /dev/null
+++ b/test/py/tests/test_efi_capsule/test_files/SIGNER2.key
@@ -0,0 +1,28 @@
+-----BEGIN PRIVATE KEY-----
+MIIEvwIBADANBgkqhkiG9w0BAQEFAASCBKkwggSlAgEAAoIBAQCb4EZbY2sb4qJo
+RXWNldIay8PTMbMb7ghoRFux9F4e8IP+6rnwVTu4WP39B9/kNUxCkR9v4+rIqNpf
+tggvj3+HuCsViZdaS3t0YI7TAc37kZBKqBeK0MmEQS+Oz/H6kgr0nWqfqJY9juyt
+IomIK7CYy3qu86ThUU7tzMcumnj8N28vDqi1S5ZKRF7gtp2SKVAr2gbadoYtKm25
+2jzpxJ+Bx/Xe5fAvTbyBneyF35J1tPjSZ2u2jII3yPhJvmSHx3nfrNpl4BuXc4DC
+voj1o7njxRk0YV7CQBtY8OJVZ4WmCdC4BncEkqMcf3BEv5Bs0SopNMxQAk/ZHtbv
+oy0AteyjAgMBAAECggEAA2Rypr63qbz/2gzk8MAzErIFLYP8r2qgFGpxPaK69HZs
+kPz/ySfs64ER6gW+JpCblV+xYCiE+nmX4xLEA9deKBCAhr2RvzChKH7veZuMJZT2
+uUE5d4pxHRrXRtOzIvs2fmz5avpRM4uR20TDDhhRUn0r/g6MZvqNIRmRt8U7eKKD
+524QheUKxgnz6GjWbAowHpi5XCnpl8nw4AjjOoxnquGkxgjSGo3BgRBWin4Uj051
+UVpQejTN05QKacoNpvC+hrsAcU1N75Lm1vPlkbK2EIk/flcm//WiK4TvKtNmHnxl
+L9ZL/LNSwX/9Hczox+b5Z+JR7I/l8/jA+TVOO4KUXQKBgQDU2u02wiszmh9dkgB7
+tUTmPmOOmKbuHslv5KBT3zVtJKjVkJHzKKkQqnQ2NcWUYz2QhZrPz26UblDigy3e
+Gf93GXJHJCgfLwNzrJrGE4zttBX4qmST1huueerTVuncVsTJhHhOiw8yV3RKNslc
+PGHqTlpCw0lpA5hYXQxxerx/bwKBgQC7eLKMrrHq/iBP6S+1w0u7nTmYmj+QkkbP
+o0Oghc5Roe8s/+BEbgi5VZEhemcEqV/fXl13WxqMdIrg8p3DgkLf4wyT9L82Yrkr
+yWKc9XWEy+NQ7isAv3r3w/TdxLh4fgp8IVvBF3DV8QJsN6I1Q5f9vW5uilTDm0Ng
+cZ7/3lnMDQKBgQCN8PwU8wCKJbHa3PzTgfrTKzGKqsNOsVsU8bn0lDl1cefgmsqp
+AylSwshCSjNak58/W8jz4VjVRIdNtbqFjIKuMlrhk/vpZ5l+rtB7XBgzf07ThxUQ
+/Mty2zw7+I5076vE0kDD57mXkXgr8ULv7hhBfkR0lvPCQrJ54nrkxbsjowKBgQC5
+g84Eg1dS+NlW2qW406Lc7NAzH+jpEqd6D9D7R44MoBeDy03NyaleZbtxiqPpLAbQ
+jpwlYYUbGrTXt57A+uVckl0/CMIzemxNVUL9mbUKjYzL6HOrkNCJ4GMvFd2Kdwe/
+IG+g26ZwP8gq+L7OwK3mjY97We5ZhwqcpLM39nub/QKBgQCTYW0YizRU8cNnC1Qv
++5SpSNjS04OLjKto1hOPzHnJMj5A2lp9ZObzjrMbyAxbzQMcwUe/V4PKiaNwypPE
+uLWkoH9QrS9qV4b5qbtCn3PAyJODscFkn+VFxgGizZvd48Ze5V2U4JwS13QMYMCe
+VHiogc9HvLI5XzE/YAfE4C7hKA==
+-----END PRIVATE KEY-----
diff --git a/test/py/tests/test_efi_capsule/test_files/u-boot.bin.new b/test/py/tests/test_efi_capsule/test_files/u-boot.bin.new
new file mode 100644
index 0000000000..798bfcb5e9
--- /dev/null
+++ b/test/py/tests/test_efi_capsule/test_files/u-boot.bin.new
@@ -0,0 +1 @@
+u-boot:New
\ No newline at end of file
diff --git a/test/py/tests/test_efi_capsule/test_files/u-boot.bin.old b/test/py/tests/test_efi_capsule/test_files/u-boot.bin.old
new file mode 100644
index 0000000000..cd6427b0f7
--- /dev/null
+++ b/test/py/tests/test_efi_capsule/test_files/u-boot.bin.old
@@ -0,0 +1 @@
+u-boot:Old
\ No newline at end of file
diff --git a/test/py/tests/test_efi_capsule/test_files/u-boot.env.new b/test/py/tests/test_efi_capsule/test_files/u-boot.env.new
new file mode 100644
index 0000000000..b2c4bd4cee
--- /dev/null
+++ b/test/py/tests/test_efi_capsule/test_files/u-boot.env.new
@@ -0,0 +1 @@
+u-boot-env:New
\ No newline at end of file
diff --git a/test/py/tests/test_efi_capsule/test_files/u-boot.env.old b/test/py/tests/test_efi_capsule/test_files/u-boot.env.old
new file mode 100644
index 0000000000..04ad4c0ad4
--- /dev/null
+++ b/test/py/tests/test_efi_capsule/test_files/u-boot.env.old
@@ -0,0 +1 @@
+u-boot-env:Old
\ No newline at end of file